package rachunek1;

import java.util.*;

public class TAplikacja {

    static private List<TProdukt1> Produkty = new ArrayList<TProdukt1>();
    static private List<TRachunek> Rachunki = new ArrayList<TRachunek>();

    public void Wstaw_zakup(int nr, int ile, String dane[]) {
        TRachunek rachunek;
        TFabryka fabryka = new TFabryka();
        TProdukt1 produkt1 = fabryka.Podaj_produkt(dane);
        if ((rachunek = Szukaj_rachunek(nr)) != null) {
            if ((produkt1 = Szukaj_produkt(produkt1)) != null) {
                rachunek.Dodaj_zakup(new TZakup(ile, produkt1));
            }
        }
    }

    public TRachunek Szukaj_rachunek(int nr) {
        TRachunek rachunek = new TRachunek(nr);
        int idx;
        if ((idx = Rachunki.indexOf(rachunek)) != -1) {
            rachunek = Rachunki.get(idx);
            return rachunek;
        }
        return null;
    }

    public float Podaj_wartosc(int nr, int podatek_) {
        TRachunek rachunek;
        rachunek = Szukaj_rachunek(nr);
        if (rachunek != null) {
            return rachunek.Podaj_wartosc(podatek_);
        }
        return 0;
    }

    public TProdukt1 Szukaj_produkt(TProdukt1 produkt) {
        int idx;
        if ((idx = Produkty.indexOf(produkt)) != -1) {
            produkt = Produkty.get(idx);
            return produkt;
        }
        return null;
    }

    public void Dodaj_produkt(String dane[]) {
        TFabryka fabryka = new TFabryka();
        TProdukt1 produkt = fabryka.Podaj_produkt(dane);
        if (Szukaj_produkt(produkt) == null) {
            Produkty.add(produkt);
        }
    }

    public void Wstaw_rachunek(int nr) {
        TRachunek rachunek = new TRachunek(nr);
        if (Szukaj_rachunek(nr) == null) {
            Rachunki.add(rachunek);
        }
    }

    public void Wyswietl_produkty() {
        TProdukt1 produkt;
        Iterator<TProdukt1> it = Produkty.iterator();
        while (it.hasNext()) {
            produkt = it.next();
            System.out.println(produkt.toString());
        }
    }

    public void Wyswietl_rachunki() {
        TRachunek rachunek;
        Iterator<TRachunek> it = Rachunki.iterator();
        while (it.hasNext()) {
            rachunek = it.next();
            System.out.println(rachunek.toString());
        }
    }

    public List<TProdukt1> getProdukty() {
        return Produkty;
    }

    public void setProdukty(ArrayList<TProdukt1> val) {
        this.Produkty = val;
    }

    public List<TRachunek> getRachunki() {
        return Rachunki;
    }

    public void setRachunki(ArrayList<TRachunek> val) {
        this.Rachunki = val;
    }

    public static void main(String args[]) {
        TAplikacja app = new TAplikacja();
        String dane1[] = {"0", "1", "1"};
        String dane2[] = {"0", "2", "2"};
        app.Dodaj_produkt(dane1);
        app.Dodaj_produkt(dane2);
        app.Dodaj_produkt(dane1);
        String dane3[] = {"2", "3", "3", "14"};
        String dane4[] = {"2", "4", "4", "22"};
        app.Dodaj_produkt(dane3);  //app.Wyswietl();
        app.Dodaj_produkt(dane4);  //app.Wyswietl();  
        app.Dodaj_produkt(dane3);   //app.Wyswietl();
        String dane5[] = {"1", "5", "1", "30"};
        String dane6[] = {"1", "6", "2", "50"};
        String dane7[] = {"3", "7", "3", "3", "30"};
        String dane8[] = {"3", "8", "4", "7", "50"};
        app.Dodaj_produkt(dane5);
        app.Dodaj_produkt(dane6);
        app.Dodaj_produkt(dane5);
        app.Dodaj_produkt(dane7);
        app.Dodaj_produkt(dane8);
        app.Dodaj_produkt(dane7);
        System.out.println("\nProdukty\n");
        app.Wyswietl_produkty();
        app.Wstaw_rachunek(1);
        app.Wstaw_rachunek(1);
        app.Wstaw_rachunek(2);
        app.Wstaw_zakup(1, 1, dane1);
        app.Wstaw_zakup(1, 2, dane2);
        app.Wstaw_zakup(1, 1, dane3);
        app.Wstaw_zakup(1, 4, dane4);
        app.Wstaw_zakup(1, 1, dane5);
        app.Wstaw_zakup(2, 1, dane6);
        app.Wstaw_zakup(2, 3, dane7);
        app.Wstaw_zakup(2, 1, dane8);
        app.Wstaw_zakup(2, 4, dane2);
        app.Wstaw_zakup(2, 1, dane4);
        app.Wstaw_zakup(2, 1, dane6);
        app.Wstaw_zakup(2, 1, dane8);
        app.Wyswietl_rachunki();

        System.out.println("\nRachunki\n");
        TRachunek pom;
        if ((pom = app.Szukaj_rachunek(1)) != null) {
            System.out.println(pom.toString());
        }
        if ((pom = app.Szukaj_rachunek(2)) != null) {
            System.out.println(pom.toString());
        }
    }
}
